/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.junit.tests;import java.math.BigDecimal;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;

import gz.cyberbrain.cyberhotel.junit.tests.facade.delegate.TestFacadeDelegate;
import gz.cyberbrain.cyberhotel.junit.tests.facade.delegate.TestFacadeDelegateFactory;
import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.bank.to.BankTo;
import gz.cyberbrain.cyberhotel.model.board.to.BoardTo;
import gz.cyberbrain.cyberhotel.model.card.to.CardTo;
import gz.cyberbrain.cyberhotel.model.client.to.AgencyTo;
import gz.cyberbrain.cyberhotel.model.client.to.CompanyTo;
import gz.cyberbrain.cyberhotel.model.client.to.ParticularTo;
import gz.cyberbrain.cyberhotel.model.concept.dao.ConceptDao;
import gz.cyberbrain.cyberhotel.model.concept.to.ConceptTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.AddressInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BankWithClientsException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BoardInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BoardTariffiedException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.CardWithClientsException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeTariffiedException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomTypeInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomWithBoardersException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UserInUseException;
import gz.cyberbrain.cyberhotel.model.owe.to.OweTo;
import gz.cyberbrain.cyberhotel.model.price.to.PriceTo;
import gz.cyberbrain.cyberhotel.model.pricetype.to.PriceTypeTo;
import gz.cyberbrain.cyberhotel.model.request.to.RequestTo;
import gz.cyberbrain.cyberhotel.model.reservation.to.ReservationTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.delegate.ReservationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.AgencyWithReservationsException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.CancelledReservationException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.CompanyWithReservationsException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.DifferentDayException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.FinishedReservationException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidDocumentTypeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidPayModeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidSexException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ParticularWithOwesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ParticularWithReservationsException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.PendingReservationException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RegisteredReservationException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RoomBusyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RoomNotBusyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAddressException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAgencyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableBankException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableEmployeeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableReservationException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnregisteredReservationException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableBoardException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCardException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCompanyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableConceptException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableInvoiceException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableParticularException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptablePayerException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptablePriceTypeException;
import gz.cyberbrain.cyberhotel.model.day.to.DayTo;
import gz.cyberbrain.cyberhotel.model.employee.to.EmployeeTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableRoomException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnavailableRoomException;
import gz.cyberbrain.cyberhotel.model.role.to.RoleTo;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.roomtype.to.RoomTypeTo;
import gz.cyberbrain.cyberhotel.model.season.to.SeasonTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.SpringDaoFactory;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.user.to.UserTo;
import gz.cyberbrain.cyberhotel.model.util.config.ConfigurationHandler;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InvalidIntervalException;
import gz.cyberbrain.cyberhotel.model.util.money.MoneyOperations;
import gz.cyberbrain.cyberhotel.model.wash.to.WashTo;
import gz.cyberbrain.cyberhotel.security.SecurityHandler;

import org.springframework.test.AbstractTransactionalDataSourceSpringContextTests;

public class ReservationFacadeDelegateTest extends AbstractTransactionalDataSourceSpringContextTests {

	private ConfigurationFacadeDelegate config;
	private ReservationFacadeDelegate delegate;	
	private TestFacadeDelegate testDelegate;
	private UserTo manager;
	private UserTo receptionist;
	private AddressTo address;
	private BankTo bank;
	private CardTo card;
	private RoomTypeTo roomType;
	private RoomTypeTo roomType2;
	private RoomTo room;
	private RoomTo room2;
	private BoardTo board;
	private PriceTypeTo priceType;
	private SeasonTo season;
	private PriceTo price;
	private EmployeeTo employee;
	private ParticularTo particular;
	private AgencyTo agency;
	private CompanyTo company;
	private ReservationTo reservation;
	private ReservationTo reservation2;
	private Collection <DayTo> days = new ArrayList<DayTo>();

	Collection<RequestTo> requests = new HashSet<RequestTo>();

	protected String[] getConfigLocations() {
		return new String[]{"../../Sources/applicationContext.xml"};
	}

	protected void onSetUpBeforeTransaction(){

		try {
 
			config =
				SpringFacadeFactory.getConfigurationFacadeDelegate();

			delegate =
				SpringFacadeFactory.getReservationFacadeDelegate();		

			testDelegate = TestFacadeDelegateFactory.getTestFacadeDelegate();

			SecurityHandler.setSecureContext("admin", "admin");

			RoleTo roleUser = new RoleTo("ROLE_USER");
			Collection<RoleTo>roles1 = new HashSet<RoleTo>();
			roles1.add(roleUser);

			receptionist = new UserTo("receptionist","goodPass",null,roles1);
			System.out.println("RECEPCIONISTA");
			config.registerUser(receptionist);
			

			RoleTo roleManager = new RoleTo("ROLE_MANAGER");
			Collection<RoleTo>roles2 = new HashSet<RoleTo>();
			roles2.add(roleManager);

			manager = new UserTo("manager","goodPass",null,roles2);
			System.out.println("MANAGER");
			config.registerUser(manager);

			SecurityHandler.clearSecurityContext();

			SecurityHandler.setSecureContext("manager", "goodPass");

			address = new AddressTo(null,"Espaa", "A Corua", "A Baa");
			bank = new BankTo(null, "Banco Gallego", "BGallego.jpg");
			card = new CardTo(null,"4B", "Tarxeta4B.jpg");

			address = config.createAddress(address);
			bank = config.createBank(bank);
			card = config.createCard(card);

			roomType = new RoomTypeTo("IN","Habitacin Individual");
			roomType2 = new RoomTypeTo("DB","Habitacin Dobre");
			room = new RoomTo("IN101","101",1,"IN","Libre","Limpa",Calendar.getInstance(),false,1,"");
			room2 = new RoomTo("DB202","202",2,"DB","Libre","Limpa",Calendar.getInstance(),false,1,"");

			roomType = config.createRoomType(roomType);
			roomType2 = config.createRoomType(roomType2);
			config.createRoom(room);
			config.createRoom(room2);

			board = new BoardTo("PC","Pensin Completa");
			priceType = new PriceTypeTo("IND", "Tarifa Individual");
			season = new SeasonTo(null,"Baixa", "Temporada Baixa");

			board = config.createBoard(board);
			priceType = config.createPriceType(priceType);
			season = config.createSeason(season);

			price = new PriceTo(new Long(1), new BigDecimal(30),"PC", "IND", season.getSeasonId());
			config.createPrice(price);

			/* Days of March */

			Calendar date = Calendar.getInstance();

			for (int i=1; i<32; i++) {

				date.set(2007,2,i,0,0,0);
				days.add(new DayTo(date, season.getSeasonId()));				

			}

			Iterator iter = days.iterator();

			for (int i=0; iter.hasNext(); i++) config.createDay((DayTo)iter.next());

			/* *************** */

			Calendar born = Calendar.getInstance();
			Calendar hireDate = Calendar.getInstance();
			born.set(1970,1-1,1,0,0,0);
			hireDate.set(2000,1-1,1,0,0,0);
			BigDecimal salary = new BigDecimal("1000.50");			

			employee = new EmployeeTo(null,"12345678X","Alberto","Gonzlez","Prez",born,"H","Casado",address.getAddressId(),"AldeaX","n10","981880000","","Recepcionista",hireDate,salary,"Atento");
			config.createEmployee(employee);

			SecurityHandler.clearSecurityContext();

			SecurityHandler.setSecureContext("receptionist","goodPass");

			Calendar bornDate = Calendar.getInstance();
			bornDate.set(1982,8,24,0,0,0);

			Calendar expeditionDate = Calendar.getInstance();
			expeditionDate.set(2002,2,25,0,0,0);

			Calendar expirationDate = Calendar.getInstance();
			expirationDate.set(2007,2,25,0,0,0);

			particular = new ParticularTo(null,address.getAddressId(),"Ceiln","","981886186","658319325","",
					"davide05@gmail.com","www.comunidadegalega.tk", bank.getBankId(), card.getCardId(), "Sen observacins",
					"David", "Ferreiro", "Nieto", bornDate, "DNI", "44841107P", expeditionDate, expirationDate, "H", "Espaa",
					"Informtico", null, "Tarxeta", "", "5489250027023605", "", "");

			delegate.insertAParticular(particular);

			agency = new AgencyTo(null, address.getAddressId(), "Alcalde Liao Flores", "5 Izq", "981905317", "", "", 
					"turhotel@hotmail.com", "www.turhotel.com", bank.getBankId(), card.getCardId(), "Axencia Barata",
					"Q12345678", "TurHotel", "TurMan", "Contado","1234567887654321", "");

			delegate.insertAnAgency(agency);

			company = new CompanyTo(null, address.getAddressId(), "Aaiun", "1", "", "678243944", "", 
					"desktop@desktop.com.es", "www.desktop.com.es", bank.getBankId(), card.getCardId(), "",
					"Q12345678", "Desktop", "Xabier","1234567887654321");

			delegate.insertACompany(company);

			Calendar incomingDate = Calendar.getInstance();
			incomingDate.set(2007,2,1,0,0,0);

			Calendar expectedOutgoingDate = Calendar.getInstance();
			expectedOutgoingDate.set(2007,2,15,0,0,0);

			Calendar trueOutgoingDate = expectedOutgoingDate;

			reservation = new ReservationTo(null, "Davide", "44841107P", "", "5489250027023605", "658319325", "Pendente",
					incomingDate, expectedOutgoingDate, trueOutgoingDate, particular.getClientId(), agency.getClientId(), company.getClientId(),
					"",false);

			RequestTo request = new RequestTo(reservation.getReservationId(), particular.getClientId(), room.getRoomCode(),
					board.getBoardCode(), priceType.getPriceTypeCode());

			requests.add(request);

			reservation = delegate.makeAReservation(reservation, requests);

			delegate.checkIn(reservation);

			incomingDate.set(2007, 2, 16, 0, 0, 0);
			expectedOutgoingDate.set(2007, 2, 31, 0, 0, 0);
			trueOutgoingDate = expectedOutgoingDate;

			reservation2 = new ReservationTo(null, "Jos", "44841107P", "", "5489250027023605", "658319325", "Pendente",
					incomingDate, expectedOutgoingDate, trueOutgoingDate, particular.getClientId(), agency.getClientId(), company.getClientId(),
					"",false);

			reservation2 = delegate.makeAReservation(reservation2, requests);

			/* ******************************************* */

			SecurityHandler.clearSecurityContext();

			SecurityHandler.setSecureContext("manager", "goodPass");

			room.setOccupancyStatus("Libre"); //For new check-in else RoomBusyException is thrown

			config.updateRoom(room);

			SecurityHandler.clearSecurityContext();

			/* ******************************************* */

			SecurityHandler.setSecureContext("receptionist","goodPass");			

			delegate.checkIn(reservation2);
			delegate.checkOut(reservation2, trueOutgoingDate);

		} catch (RoomBusyException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidSexException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidDocumentTypeException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableParticularException e) {		
			e.printStackTrace();
			fail();
		} catch (UnaceptableBoardException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePriceTypeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAgencyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePayerException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnavailableRoomException e) {
			e.printStackTrace();
			fail();
		}  catch (DifferentDayException e) {
			e.printStackTrace();
			fail();
		} catch (FinishedReservationException e) {
			e.printStackTrace();
			fail();
		} catch (CancelledReservationException e) {
			e.printStackTrace();
			fail();
		} catch (RegisteredReservationException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableConceptException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableInvoiceException e) {
			e.printStackTrace();
			fail();
		} catch (RoomNotBusyException e) {
			e.printStackTrace();
			fail();
		} catch (PendingReservationException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {			
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();		
		}
	}

	protected void onTearDownAfterTransaction(){
 
		try {
			
			reservation2.setReservationStatus("Anulada"); //For elimination else 
			//RegisteredReservationException is thrown
			delegate.updateAReservation(reservation2, requests);

			delegate.removeACheckIn(reservation);
			delegate.removeAReservation(reservation);
			delegate.removeAReservation(reservation2);
			delegate.removeAParticular(particular);
			delegate.removeAnAgency(agency);
			delegate.removeACompany(company);

			SecurityHandler.clearSecurityContext();

			SecurityHandler.setSecureContext("manager", "goodPass");

			Iterator iter = days.iterator();

			for (int i=0; iter.hasNext(); i++) config.deleteDay((DayTo)iter.next());

			config.deleteEmployee(employee);
			config.deleteAddress(address);
			config.deleteBank(bank);
			config.deleteCard(card);

			config.deleteRoom(room);
			config.deleteRoom(room2);
			config.deleteRoomType(roomType);
			config.deleteRoomType(roomType2);

			config.deletePrice(price);

			config.deleteBoard(board);
			config.deletePriceType(priceType);
			config.deleteSeason(season);

			SecurityHandler.clearSecurityContext();

			SecurityHandler.setSecureContext("admin", "admin");

			System.out.println("RECEPCIONISTA_BORRADO");
			config.removeUser(receptionist);
			System.out.println("MANAGER_BORRADO");
			config.removeUser(manager);

			SecurityHandler.clearSecurityContext();

		} catch (CompanyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (AgencyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ParticularWithOwesException e) {
			e.printStackTrace();
			fail();
		} catch (ParticularWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();				
		} catch (AddressInUseException e) {
			e.printStackTrace();
			fail();
		} catch (BankWithClientsException e) {
			e.printStackTrace();
			fail();
		} catch (CardWithClientsException e) {
			e.printStackTrace();
			fail();
		} catch (RoomWithBoardersException e) {
			e.printStackTrace();
			fail();
		} catch (RoomTypeInUseException e) {
			e.printStackTrace();
			fail();
		} catch (BoardInUseException e) {
			e.printStackTrace();
			fail();
		} catch (BoardTariffiedException e) {
			e.printStackTrace();
			fail();
		} catch (PriceTypeInUseException e) {
			e.printStackTrace();
			fail();
		} catch (PriceTypeTariffiedException e) {
			e.printStackTrace();
			fail();
		} catch (UserInUseException e) {
			e.printStackTrace();
			fail();		
		} catch (RegisteredReservationException e) {
			e.printStackTrace();
			fail();			
		}  catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBoardException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePriceTypeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAgencyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePayerException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnavailableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
		} catch (FinishedReservationException e) {
			e.printStackTrace();
			fail();
		} catch (CancelledReservationException e) {
			e.printStackTrace();
			fail();
		} catch (UnregisteredReservationException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();		
		} 
	}		
	
	public void testInsertAParticular() {

		try {

			Calendar bornDate = Calendar.getInstance();
			bornDate.set(1943,4,21,0,0,0);

			Calendar expeditionDate = Calendar.getInstance();
			expeditionDate.set(2002,2,25,0,0,0);

			Calendar expirationDate = Calendar.getInstance();
			expirationDate.set(2007,2,25,0,0,0);


			ParticularTo newParticular = new ParticularTo(null,address.getAddressId(),"Ceiln","","981886186","","",
					"davide05@gmail.com","www.comunidadegalega.tk", bank.getBankId(), card.getCardId(), "Sen observacins",
					"Jos", "Ferreiro", "Caamao", bornDate, "DNI", "98765432J", expeditionDate, expirationDate, "H", "Espaa",
					"Pensionista", null, "Contado", "5489250027023605", "", "", "");

			newParticular = delegate.insertAParticular(newParticular);

			ParticularTo obtainedParticular = (ParticularTo) testDelegate.findParticular(newParticular.getClientId());

			boolean test = obtainedParticular.getClientId().equals(newParticular.getClientId())
			&& obtainedParticular.getAddress().equals(newParticular.getAddress())
			&& obtainedParticular.getStreet().equals(newParticular.getStreet())
			&& obtainedParticular.getDwellingPlace().equals(newParticular.getDwellingPlace())
			&& obtainedParticular.getPhone1().equals(newParticular.getPhone1())
			&& obtainedParticular.getPhone2().equals(newParticular.getPhone2())
			&& obtainedParticular.getFax().equals(newParticular.getFax())
			&& obtainedParticular.getEmail().equals(newParticular.getEmail())
			&& obtainedParticular.getWeb().equals(newParticular.getWeb())
			&& obtainedParticular.getBank().equals(newParticular.getBank())
			&& obtainedParticular.getCard().equals(newParticular.getCard())
			&& obtainedParticular.getNotes().equals(newParticular.getNotes())
			&& obtainedParticular.getName().equals(newParticular.getName())
			&& obtainedParticular.getFirstSurname().equals(newParticular.getFirstSurname())
			&& obtainedParticular.getSecondSurname().equals(newParticular.getSecondSurname())
			&& obtainedParticular.getBornDate().equals(newParticular.getBornDate())
			&& obtainedParticular.getDocumentType().equals(newParticular.getDocumentType())
			&& obtainedParticular.getDocumentNumber().equals(newParticular.getDocumentNumber())
			&& obtainedParticular.getExpeditionDate().equals(newParticular.getExpeditionDate())
			&& obtainedParticular.getExpirationDate().equals(newParticular.getExpirationDate())
			&& obtainedParticular.getSex().equals(newParticular.getSex())
			&& obtainedParticular.getNationality().equals(newParticular.getNationality())
			&& obtainedParticular.getJob().equals(newParticular.getJob())
			&& obtainedParticular.getCompany() == newParticular.getCompany()
			&& obtainedParticular.getPayMode().equals(newParticular.getPayMode())
			&& obtainedParticular.getAccountNumber().equals(newParticular.getAccountNumber())
			&& obtainedParticular.getCardNumber().equals(newParticular.getCardNumber())
			&& obtainedParticular.getVoucherCode().equals(newParticular.getVoucherCode())
			&& obtainedParticular.getClientType().equals(newParticular.getClientType());

			delegate.removeAParticular(newParticular);

			assertTrue("insertAParticular", test);

		} catch (InvalidSexException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidDocumentTypeException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
		} catch (ParticularWithOwesException e) {
			e.printStackTrace();
			fail();
		} catch (ParticularWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testUpdateAParticular() {

		try {

			Calendar bornDate = Calendar.getInstance();
			bornDate.set(2002,3,18,0,0,0);

			Calendar expeditionDate = Calendar.getInstance();
			expeditionDate.set(2007,2,25,0,0,0);

			Calendar expirationDate = Calendar.getInstance();
			expirationDate.set(2010,2,25,0,0,0);


			ParticularTo newParticular = new ParticularTo(null,address.getAddressId(),"Vilagarca","","986123456","612345678","",
					"elena@hotmail.com","www.elenaferreiro.com", bank.getBankId(), card.getCardId(), "Sen observacins",
					"Elena", "Ferreiro", "Lema", bornDate, "DNI", "12345678J", expeditionDate, expirationDate, "M", "Espaa",
					"Estudiante", null, "Tarxeta", "", "1234567890123456", "", "");

			newParticular = delegate.insertAParticular(newParticular);

			ParticularTo obtainedParticular = (ParticularTo) testDelegate.findParticular(newParticular.getClientId());

			obtainedParticular.setPayMode("Contado");
			obtainedParticular.setAccountNumber("6543210987654321");
			obtainedParticular.setCardNumber("");
			obtainedParticular.setBank(null);
			obtainedParticular.setCard(null);

			delegate.updateAParticular(obtainedParticular);

			ParticularTo updatedParticular = (ParticularTo) testDelegate.findParticular(obtainedParticular.getClientId());

			boolean test = obtainedParticular.getClientId().equals(updatedParticular.getClientId())
			&& obtainedParticular.getAddress().equals(newParticular.getAddress())
			&& obtainedParticular.getStreet().equals(updatedParticular.getStreet())
			&& obtainedParticular.getDwellingPlace().equals(updatedParticular.getDwellingPlace())
			&& obtainedParticular.getPhone1().equals(updatedParticular.getPhone1())
			&& obtainedParticular.getPhone2().equals(updatedParticular.getPhone2())
			&& obtainedParticular.getFax().equals(updatedParticular.getFax())
			&& obtainedParticular.getEmail().equals(updatedParticular.getEmail())
			&& obtainedParticular.getWeb().equals(updatedParticular.getWeb())
			&& obtainedParticular.getBank() == updatedParticular.getBank()
			&& obtainedParticular.getCard() == updatedParticular.getCard()
			&& obtainedParticular.getNotes().equals(updatedParticular.getNotes())
			&& obtainedParticular.getName().equals(updatedParticular.getName())
			&& obtainedParticular.getFirstSurname().equals(updatedParticular.getFirstSurname())
			&& obtainedParticular.getSecondSurname().equals(updatedParticular.getSecondSurname())
			&& obtainedParticular.getBornDate().equals(updatedParticular.getBornDate())
			&& obtainedParticular.getDocumentType().equals(updatedParticular.getDocumentType())
			&& obtainedParticular.getDocumentNumber().equals(updatedParticular.getDocumentNumber())
			&& obtainedParticular.getExpeditionDate().equals(updatedParticular.getExpeditionDate())
			&& obtainedParticular.getExpirationDate().equals(updatedParticular.getExpirationDate())
			&& obtainedParticular.getSex().equals(updatedParticular.getSex())
			&& obtainedParticular.getNationality().equals(updatedParticular.getNationality())
			&& obtainedParticular.getJob().equals(updatedParticular.getJob())
			&& obtainedParticular.getCompany() == updatedParticular.getCompany()
			&& obtainedParticular.getPayMode().equals(updatedParticular.getPayMode())
			&& obtainedParticular.getAccountNumber().equals(updatedParticular.getAccountNumber())
			&& obtainedParticular.getCardNumber().equals(updatedParticular.getCardNumber())
			&& obtainedParticular.getVoucherCode().equals(updatedParticular.getVoucherCode())
			&& obtainedParticular.getClientType().equals(updatedParticular.getClientType());

			delegate.removeAParticular(newParticular);

			assertTrue("updateAParticular", test);

		} catch (InvalidSexException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidDocumentTypeException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
		}  catch (ParticularWithOwesException e) {
			e.printStackTrace();
			fail();
		} catch (ParticularWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testRemoveAParticular() {

		try {

			Calendar bornDate = Calendar.getInstance();
			bornDate.set(2002,3,18,0,0,0);

			Calendar expeditionDate = Calendar.getInstance();
			expeditionDate.set(2007,2,25,0,0,0);

			Calendar expirationDate = Calendar.getInstance();
			expirationDate.set(2010,2,25,0,0,0);

			ParticularTo newParticular = new ParticularTo(null,address.getAddressId(),"Vilagarca","","986123456","612345678","",
					"elena@hotmail.com","www.elenaferreiro.com", bank.getBankId(), card.getCardId(), "Sen observacins",
					"Elena", "Ferreiro", "Lema", bornDate, "DNI", "12345678J", expeditionDate, expirationDate, "M", "Espaa",
					"Estudiante", null, "Tarxeta", "", "1234567890123456", "", "");

			newParticular = delegate.insertAParticular(newParticular);

			delegate.removeAParticular(newParticular);

			newParticular = (ParticularTo) testDelegate.findParticular(newParticular.getClientId());

			assertTrue("removeAParticular", false);

		} catch (InvalidSexException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidDocumentTypeException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
		}  catch (ParticularWithOwesException e) {
			e.printStackTrace();
			fail();
		} catch (ParticularWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			assertTrue("removeAParticular", true);			
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testShowParticulars() {

		try {

			Collection particulars = delegate.showParticulars();

			Iterator iter = particulars.iterator();

			ParticularTo currentParticular;

			boolean test = true;

			for (int i=0; iter.hasNext();i++) {

				currentParticular = (ParticularTo) iter.next();

				test = currentParticular.getClientId().equals(particular.getClientId())
				&& currentParticular.getAddress().equals(particular.getAddress())
				&& currentParticular.getStreet().equals(particular.getStreet())
				&& currentParticular.getDwellingPlace().equals(particular.getDwellingPlace())
				&& currentParticular.getPhone1().equals(particular.getPhone1())
				&& currentParticular.getPhone2().equals(particular.getPhone2())
				&& currentParticular.getFax().equals(particular.getFax())
				&& currentParticular.getEmail().equals(particular.getEmail())
				&& currentParticular.getWeb().equals(particular.getWeb())
				&& currentParticular.getBank().equals(particular.getBank())
				&& currentParticular.getCard().equals(particular.getCard())
				&& currentParticular.getNotes().equals(particular.getNotes())
				&& currentParticular.getName().equals(particular.getName())
				&& currentParticular.getFirstSurname().equals(particular.getFirstSurname())
				&& currentParticular.getSecondSurname().equals(particular.getSecondSurname())
				&& currentParticular.getBornDate().equals(particular.getBornDate())
				&& currentParticular.getDocumentType().equals(particular.getDocumentType())
				&& currentParticular.getDocumentNumber().equals(particular.getDocumentNumber())
				&& currentParticular.getExpeditionDate().equals(particular.getExpeditionDate())
				&& currentParticular.getExpirationDate().equals(particular.getExpirationDate())
				&& currentParticular.getSex().equals(particular.getSex())
				&& currentParticular.getNationality().equals(particular.getNationality())
				&& currentParticular.getJob().equals(particular.getJob())
				&& currentParticular.getCompany() == particular.getCompany()
				&& currentParticular.getPayMode().equals(particular.getPayMode())
				&& currentParticular.getAccountNumber().equals(particular.getAccountNumber())
				&& currentParticular.getCardNumber().equals(particular.getCardNumber())
				&& currentParticular.getVoucherCode().equals(particular.getVoucherCode())
				&& currentParticular.getClientType().equals(particular.getClientType());								
			}

			assertTrue("ShowParticulars", test);

		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testInsertAnAgency() {

		try {

			AgencyTo newAgency = new AgencyTo(null, address.getAddressId(), "Ronda de Nelle", "8 Izq", "981905317", "", "", 
					"tomahotel@hotmail.com", "www.tomahotel.com", bank.getBankId(), card.getCardId(), "Axencia Rpida",
					"Q87654321", "TomaHotel", "TomaMan", "Tarxeta","", "1234567887654321");

			newAgency = delegate.insertAnAgency(newAgency);

			AgencyTo obtainedAgency = (AgencyTo) testDelegate.findAgency(newAgency.getClientId());

			boolean test = obtainedAgency.getClientId().equals(newAgency.getClientId())
			&& obtainedAgency.getAddress().equals(newAgency.getAddress())
			&& obtainedAgency.getStreet().equals(newAgency.getStreet())
			&& obtainedAgency.getDwellingPlace().equals(newAgency.getDwellingPlace())
			&& obtainedAgency.getPhone1().equals(newAgency.getPhone1())
			&& obtainedAgency.getPhone2().equals(newAgency.getPhone2())
			&& obtainedAgency.getFax().equals(newAgency.getFax())
			&& obtainedAgency.getEmail().equals(newAgency.getEmail())
			&& obtainedAgency.getWeb().equals(newAgency.getWeb())
			&& obtainedAgency.getBank().equals(newAgency.getBank())
			&& obtainedAgency.getCard().equals(newAgency.getCard())
			&& obtainedAgency.getNotes().equals(newAgency.getNotes())
			&& obtainedAgency.getCif().equals(newAgency.getCif())
			&& obtainedAgency.getName().equals(newAgency.getName())
			&& obtainedAgency.getContact().equals(newAgency.getContact())					
			&& obtainedAgency.getPayMode().equals(newAgency.getPayMode())
			&& obtainedAgency.getAccountNumber().equals(newAgency.getAccountNumber())
			&& obtainedAgency.getCardNumber().equals(newAgency.getCardNumber());

			delegate.removeAnAgency(newAgency);

			assertTrue("insertAAgency", test);

		} catch (InvalidPayModeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (AgencyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testUpdateAnAgency() {

		try {

			AgencyTo newAgency = new AgencyTo(null, address.getAddressId(), "Ronda de Nelle", "8 Izq", "981905317", "", "", 
					"tomahotel@hotmail.com", "www.tomahotel.com", bank.getBankId(), card.getCardId(), "Axencia Rpida",
					"Q87654321", "TomaHotel", "TomaMan", "Tarxeta","", "1234567887654321");

			newAgency = delegate.insertAnAgency(newAgency);

			AgencyTo obtainedAgency = (AgencyTo) testDelegate.findAgency(newAgency.getClientId());

			obtainedAgency.setPayMode("Contado");
			obtainedAgency.setAccountNumber("6543210987654321");
			obtainedAgency.setCardNumber("");
			obtainedAgency.setContact("TomaWoman");


			delegate.updateAnAgency(obtainedAgency);

			AgencyTo updatedAgency = (AgencyTo) testDelegate.findAgency(obtainedAgency.getClientId());

			boolean test = obtainedAgency.getClientId().equals(updatedAgency.getClientId())
			&& obtainedAgency.getAddress().equals(newAgency.getAddress())
			&& obtainedAgency.getStreet().equals(updatedAgency.getStreet())
			&& obtainedAgency.getDwellingPlace().equals(updatedAgency.getDwellingPlace())
			&& obtainedAgency.getPhone1().equals(updatedAgency.getPhone1())
			&& obtainedAgency.getPhone2().equals(updatedAgency.getPhone2())
			&& obtainedAgency.getFax().equals(updatedAgency.getFax())
			&& obtainedAgency.getEmail().equals(updatedAgency.getEmail())
			&& obtainedAgency.getWeb().equals(updatedAgency.getWeb())
			&& obtainedAgency.getBank().equals(updatedAgency.getBank())
			&& obtainedAgency.getCard().equals(updatedAgency.getCard())
			&& obtainedAgency.getNotes().equals(updatedAgency.getNotes())
			&& obtainedAgency.getCif().equals(updatedAgency.getCif())
			&& obtainedAgency.getName().equals(updatedAgency.getName())
			&& obtainedAgency.getContact().equals(updatedAgency.getContact())
			&& obtainedAgency.getPayMode().equals(updatedAgency.getPayMode())
			&& obtainedAgency.getAccountNumber().equals(updatedAgency.getAccountNumber())
			&& obtainedAgency.getCardNumber().equals(updatedAgency.getCardNumber());

			delegate.removeAnAgency(newAgency);

			assertTrue("updateAnAgency", test);

		} catch (InvalidPayModeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();		
		} catch (AgencyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testRemoveAnAgency() {

		try {

			AgencyTo newAgency = new AgencyTo(null, address.getAddressId(), "Ronda de Nelle", "8 Izq", "981905317", "", "", 
					"tomahotel@hotmail.com", "www.tomahotel.com", bank.getBankId(), card.getCardId(), "Axencia Rpida",
					"Q87654321", "TomaHotel", "TomaWoman", "Contado","1234567887654321", "");

			newAgency = delegate.insertAnAgency(newAgency);

			delegate.removeAnAgency(newAgency);

			newAgency = (AgencyTo) testDelegate.findAgency(newAgency.getClientId());

			assertTrue("removeAnAgency", false);

		} catch (InvalidPayModeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (AgencyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			assertTrue("removeAnAgency", true);			
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testShowAgencies() {

		try {

			Collection agencies = delegate.showAgencies();

			Iterator iter = agencies.iterator();

			AgencyTo currentAgency;

			boolean test = true;

			for (int i=0; iter.hasNext();i++) {

				currentAgency = (AgencyTo) iter.next();

				test = currentAgency.getClientId().equals(agency.getClientId())
				&& currentAgency.getAddress().equals(agency.getAddress())
				&& currentAgency.getStreet().equals(agency.getStreet())
				&& currentAgency.getDwellingPlace().equals(agency.getDwellingPlace())
				&& currentAgency.getPhone1().equals(agency.getPhone1())
				&& currentAgency.getPhone2().equals(agency.getPhone2())
				&& currentAgency.getFax().equals(agency.getFax())
				&& currentAgency.getEmail().equals(agency.getEmail())
				&& currentAgency.getWeb().equals(agency.getWeb())
				&& currentAgency.getBank().equals(agency.getBank())
				&& currentAgency.getCard().equals(agency.getCard())
				&& currentAgency.getNotes().equals(agency.getNotes())
				&& currentAgency.getCif().equals(agency.getCif())
				&& currentAgency.getName().equals(agency.getName())
				&& currentAgency.getContact().equals(agency.getContact())
				&& currentAgency.getPayMode().equals(agency.getPayMode())
				&& currentAgency.getAccountNumber().equals(agency.getAccountNumber())
				&& currentAgency.getCardNumber().equals(agency.getCardNumber());								
			}

			assertTrue("ShowAgencies", test);

		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testInsertACompany() {

		try {

			CompanyTo newCompany = new CompanyTo(null, address.getAddressId(), "Polgono do Ventorrillo", "2", "881123456", "", "", 
					"queres@hotmail.com", "www.queres.com", bank.getBankId(), card.getCardId(), "",
					"Q12345678", "Queres", "Descoecido","1234567887654321");

			newCompany = delegate.insertACompany(newCompany);

			CompanyTo obtainedCompany = (CompanyTo) testDelegate.findCompany(newCompany.getClientId());

			boolean test = obtainedCompany.getClientId().equals(newCompany.getClientId())
			&& obtainedCompany.getAddress().equals(newCompany.getAddress())
			&& obtainedCompany.getStreet().equals(newCompany.getStreet())
			&& obtainedCompany.getDwellingPlace().equals(newCompany.getDwellingPlace())
			&& obtainedCompany.getPhone1().equals(newCompany.getPhone1())
			&& obtainedCompany.getPhone2().equals(newCompany.getPhone2())
			&& obtainedCompany.getFax().equals(newCompany.getFax())
			&& obtainedCompany.getEmail().equals(newCompany.getEmail())
			&& obtainedCompany.getWeb().equals(newCompany.getWeb())
			&& obtainedCompany.getBank().equals(newCompany.getBank())
			&& obtainedCompany.getCard().equals(newCompany.getCard())
			&& obtainedCompany.getNotes().equals(newCompany.getNotes())
			&& obtainedCompany.getCif().equals(newCompany.getCif())
			&& obtainedCompany.getName().equals(newCompany.getName())
			&& obtainedCompany.getRepresentative().equals(newCompany.getRepresentative())								
			&& obtainedCompany.getAccountNumber().equals(newCompany.getAccountNumber());

			delegate.removeACompany(newCompany);

			assertTrue("insertACompany", test);

		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (CompanyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testUpdateACompany() {

		try {

			CompanyTo newCompany = new CompanyTo(null, address.getAddressId(), "Polgono do Ventorrillo", "2", "881123456", "", "", 
					"queres@hotmail.com", "www.queres.com", bank.getBankId(), card.getCardId(), "",
					"Q12345678", "Queres", "Descoecido","1234567887654321");

			newCompany = delegate.insertACompany(newCompany);

			CompanyTo obtainedCompany = (CompanyTo) testDelegate.findCompany(newCompany.getClientId());

			obtainedCompany.setPhone2("612345678");
			obtainedCompany.setRepresentative("Torvals");

			delegate.updateACompany(obtainedCompany);

			CompanyTo updatedCompany = (CompanyTo) testDelegate.findCompany(obtainedCompany.getClientId());

			boolean test = obtainedCompany.getClientId().equals(updatedCompany.getClientId())
			&& obtainedCompany.getAddress().equals(newCompany.getAddress())
			&& obtainedCompany.getStreet().equals(updatedCompany.getStreet())
			&& obtainedCompany.getDwellingPlace().equals(updatedCompany.getDwellingPlace())
			&& obtainedCompany.getPhone1().equals(updatedCompany.getPhone1())
			&& obtainedCompany.getPhone2().equals(updatedCompany.getPhone2())
			&& obtainedCompany.getFax().equals(updatedCompany.getFax())
			&& obtainedCompany.getEmail().equals(updatedCompany.getEmail())
			&& obtainedCompany.getWeb().equals(updatedCompany.getWeb())
			&& obtainedCompany.getBank().equals(updatedCompany.getBank())
			&& obtainedCompany.getCard().equals(updatedCompany.getCard())
			&& obtainedCompany.getNotes().equals(updatedCompany.getNotes())
			&& obtainedCompany.getCif().equals(updatedCompany.getCif())
			&& obtainedCompany.getName().equals(updatedCompany.getName())
			&& obtainedCompany.getRepresentative().equals(updatedCompany.getRepresentative())
			&& obtainedCompany.getAccountNumber().equals(updatedCompany.getAccountNumber());

			delegate.removeACompany(newCompany);

			assertTrue("updateACompany", test);

		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();		
		} catch (CompanyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testRemoveACompany() {


		try {

			CompanyTo newCompany = new CompanyTo(null, address.getAddressId(), "Polgono do Ventorrillo", "2", "881123456", "612345678", "", 
					"queres@hotmail.com", "www.queres.com", bank.getBankId(), card.getCardId(), "",
					"Q12345678", "Queres", "Torvals","1234567887654321");

			newCompany = delegate.insertACompany(newCompany);

			delegate.removeACompany(newCompany);

			newCompany = (CompanyTo) testDelegate.findCompany(newCompany.getClientId());

			assertTrue("removeAnCompany", false);

		} catch (UnaceptableAddressException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBankException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCardException e) {
			e.printStackTrace();
			fail();
		} catch (CompanyWithReservationsException e) {
			e.printStackTrace();
			fail();
		} catch (ClientPayerException e) {
			e.printStackTrace();
			fail();
		} catch (ClientWithInvoicesException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			assertTrue("removeAnCompany", true);			
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testShowCompanies() {

		try {

			Collection companies = delegate.showCompanies();

			Iterator iter = companies.iterator();

			CompanyTo currentCompany;

			boolean test = true;

			for (int i=0; iter.hasNext();i++) {

				currentCompany = (CompanyTo) iter.next();

				test = currentCompany.getClientId().equals(company.getClientId())
				&& currentCompany.getAddress().equals(company.getAddress())
				&& currentCompany.getStreet().equals(company.getStreet())
				&& currentCompany.getDwellingPlace().equals(company.getDwellingPlace())
				&& currentCompany.getPhone1().equals(company.getPhone1())
				&& currentCompany.getPhone2().equals(company.getPhone2())
				&& currentCompany.getFax().equals(company.getFax())
				&& currentCompany.getEmail().equals(company.getEmail())
				&& currentCompany.getWeb().equals(company.getWeb())
				&& currentCompany.getBank().equals(company.getBank())
				&& currentCompany.getCard().equals(company.getCard())
				&& currentCompany.getNotes().equals(company.getNotes())
				&& currentCompany.getCif().equals(company.getCif())
				&& currentCompany.getName().equals(company.getName())
				&& currentCompany.getRepresentative().equals(company.getRepresentative())
				&& currentCompany.getAccountNumber().equals(company.getAccountNumber());								
			}

			assertTrue("ShowCompanies", test);

		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testMakeAReservation() {

		try {		

			Calendar incomingDate = Calendar.getInstance();
			incomingDate.set(2007,1,1,0,0,0);

			Calendar expectedOutgoingDate = Calendar.getInstance();
			expectedOutgoingDate.set(2007,1,15,0,0,0);

			Calendar trueOutgoingDate = expectedOutgoingDate;

			ReservationTo newReservation = new ReservationTo(null, "Elena", "12345678P", "", "5489250027023605", "658319325", "Pendente",
					incomingDate, expectedOutgoingDate, trueOutgoingDate, particular.getClientId(), agency.getClientId(), company.getClientId(),
					"",false);

			RequestTo newRequest = new RequestTo(newReservation.getReservationId(), particular.getClientId(), room2.getRoomCode(),
					board.getBoardCode(), priceType.getPriceTypeCode());

			Collection<RequestTo> newRequests = new HashSet<RequestTo>();
			newRequests.add(newRequest);

			newReservation = delegate.makeAReservation(newReservation, newRequests);

			ReservationTo obtainedReservation = (ReservationTo) testDelegate.findReservation(newReservation.getReservationId());

			boolean test = obtainedReservation.getReservationId().equals(newReservation.getReservationId())
			&& obtainedReservation.getReservatorName().equals(newReservation.getReservatorName())
			&& obtainedReservation.getReservatorCif().equals(newReservation.getReservatorCif())
			&& obtainedReservation.getReservatorAccount().equals(newReservation.getReservatorAccount())
			&& obtainedReservation.getReservatorCard().equals(newReservation.getReservatorCard())
			&& obtainedReservation.getReservatorPhone().equals(newReservation.getReservatorPhone())
			&& obtainedReservation.getReservationStatus().equals(newReservation.getReservationStatus())
			&& obtainedReservation.getIncomingDate().equals(newReservation.getIncomingDate())
			&& obtainedReservation.getExpectedOutgoingDate().equals(newReservation.getExpectedOutgoingDate())
			&& obtainedReservation.getTrueOutgoingDate().equals(newReservation.getTrueOutgoingDate())
			&& obtainedReservation.getPayer().equals(newReservation.getPayer())
			&& obtainedReservation.getAgency().equals(newReservation.getAgency())
			&& obtainedReservation.getCompany().equals(newReservation.getCompany())
			&& obtainedReservation.getNotes().equals(newReservation.getNotes())
			&& obtainedReservation.getByHours() == newReservation.getByHours();

			//delegate.removeAReservation(newReservation);
			//delegate.removeAReservation(newReservation); //BUG de JUnit con Spring???

			assertTrue("makeAReservation", test);

		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBoardException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePriceTypeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAgencyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePayerException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnavailableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
			/*} catch (RegisteredReservationException e) {
			e.printStackTrace();
			fail();*/			
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();				
		}

	}

	public void testUnavailableRoom() {

		try {

			Calendar incomingDate = Calendar.getInstance();
			incomingDate.set(2007,2,1,0,0,0);

			Calendar expectedOutgoingDate = Calendar.getInstance();
			expectedOutgoingDate.set(2007,2,15,0,0,0);

			Calendar trueOutgoingDate = expectedOutgoingDate;

			ReservationTo newReservation = new ReservationTo(null, "Angel", "87654321P", "", "5489250027023605", "658319325", "Pendente",
					incomingDate, expectedOutgoingDate, trueOutgoingDate, particular.getClientId(), agency.getClientId(), company.getClientId(),
					"",false);

			RequestTo newRequest = new RequestTo(newReservation.getReservationId(), particular.getClientId(), room.getRoomCode(),
					board.getBoardCode(), priceType.getPriceTypeCode());

			Collection<RequestTo> newRequests = new HashSet<RequestTo>();
			newRequests.add(newRequest);

			newReservation = delegate.makeAReservation(newReservation, newRequests);

			assertTrue("unavailableRoom", false);

		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBoardException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePriceTypeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAgencyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePayerException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnavailableRoomException e) {

			assertTrue("unavailableRoom", true);

		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();		
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();				
		}


	}

	public void testUpdateAReservation() {

		try {

			ReservationTo obtainedReservation = (ReservationTo) testDelegate.findReservation(reservation.getReservationId());

			Calendar newExpectedOutgoingDate = obtainedReservation.getExpectedOutgoingDate();
			newExpectedOutgoingDate.set(2007,2,14,0,0,0);

			obtainedReservation.setExpectedOutgoingDate(newExpectedOutgoingDate);

			delegate.updateAReservation(obtainedReservation, requests);				

			ReservationTo updatedReservation = (ReservationTo) testDelegate.findReservation(reservation.getReservationId());						

			boolean test = updatedReservation.getReservationId().equals(obtainedReservation.getReservationId())
			&& updatedReservation.getReservatorName().equals(obtainedReservation.getReservatorName())
			&& updatedReservation.getReservatorCif().equals(obtainedReservation.getReservatorCif())
			&& updatedReservation.getReservatorAccount().equals(obtainedReservation.getReservatorAccount())
			&& updatedReservation.getReservatorCard().equals(obtainedReservation.getReservatorCard())
			&& updatedReservation.getReservatorPhone().equals(obtainedReservation.getReservatorPhone())
			&& updatedReservation.getReservationStatus().equals(obtainedReservation.getReservationStatus())
			&& updatedReservation.getIncomingDate().equals(obtainedReservation.getIncomingDate())
			&& updatedReservation.getExpectedOutgoingDate().equals(obtainedReservation.getExpectedOutgoingDate())
			&& updatedReservation.getTrueOutgoingDate().equals(obtainedReservation.getTrueOutgoingDate())
			&& updatedReservation.getPayer().equals(obtainedReservation.getPayer())
			&& updatedReservation.getAgency().equals(obtainedReservation.getAgency())
			&& updatedReservation.getCompany().equals(obtainedReservation.getCompany())
			&& updatedReservation.getNotes().equals(obtainedReservation.getNotes())
			&& updatedReservation.getByHours() == obtainedReservation.getByHours();

			//delegate.removeAReservation(obtainedReservation);

			assertTrue("updateAReservation", test);

		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBoardException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePriceTypeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAgencyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePayerException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnavailableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
			/*} catch (RegisteredReservationException e) {
			e.printStackTrace();
			fail();*/			
	} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();		
		}

	}

	public void testShowReservations() {

		try {

			Collection reservations = delegate.showReservations();

			Iterator iter = reservations.iterator();

			ReservationTo currentReservation;

			boolean test = true;

			for (int i=0; iter.hasNext();i++) {

				currentReservation = (ReservationTo) iter.next();

				if (i==0) {

					test = currentReservation.getReservationId().equals(reservation.getReservationId())
					&& currentReservation.getReservatorName().equals(reservation.getReservatorName())
					&& currentReservation.getReservatorCif().equals(reservation.getReservatorCif())
					&& currentReservation.getReservatorAccount().equals(reservation.getReservatorAccount())
					&& currentReservation.getReservatorCard().equals(reservation.getReservatorCard())
					&& currentReservation.getReservatorPhone().equals(reservation.getReservatorPhone())
					&& currentReservation.getReservationStatus().equals(reservation.getReservationStatus())
					&& currentReservation.getIncomingDate().equals(reservation.getIncomingDate())
					&& currentReservation.getExpectedOutgoingDate().equals(reservation.getExpectedOutgoingDate())
					&& currentReservation.getTrueOutgoingDate().equals(reservation.getTrueOutgoingDate())
					&& currentReservation.getPayer().equals(reservation.getPayer())
					&& currentReservation.getAgency().equals(reservation.getAgency())
					&& currentReservation.getCompany().equals(reservation.getCompany())
					&& currentReservation.getNotes().equals(reservation.getNotes())
					&& currentReservation.getByHours() == reservation.getByHours();

				}

				if (i==1) {

					test = currentReservation.getReservationId().equals(reservation2.getReservationId())
					&& currentReservation.getReservatorName().equals(reservation2.getReservatorName())
					&& currentReservation.getReservatorCif().equals(reservation2.getReservatorCif())
					&& currentReservation.getReservatorAccount().equals(reservation2.getReservatorAccount())
					&& currentReservation.getReservatorCard().equals(reservation2.getReservatorCard())
					&& currentReservation.getReservatorPhone().equals(reservation2.getReservatorPhone())
					&& currentReservation.getReservationStatus().equals(reservation2.getReservationStatus())
					&& currentReservation.getIncomingDate().equals(reservation2.getIncomingDate())
					&& currentReservation.getExpectedOutgoingDate().equals(reservation2.getExpectedOutgoingDate())
					&& currentReservation.getTrueOutgoingDate().equals(reservation2.getTrueOutgoingDate())
					&& currentReservation.getPayer().equals(reservation2.getPayer())
					&& currentReservation.getAgency().equals(reservation2.getAgency())
					&& currentReservation.getCompany().equals(reservation2.getCompany())
					&& currentReservation.getNotes().equals(reservation2.getNotes())
					&& currentReservation.getByHours() == reservation2.getByHours();

				}

			}															

			assertTrue("ShowReservations", test);

		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testRemoveAReservation() {

		/* Remove done at OnTearDownAfterTransaction */
	 
		assertTrue("removeAReservation", true);

	}

	public void testRegisteredReservation() {

		try {		

			Calendar incomingDate = Calendar.getInstance();
			incomingDate.set(2007,2,1,0,0,0);

			Calendar expectedOutgoingDate = Calendar.getInstance();
			expectedOutgoingDate.set(2007,2,15,0,0,0);

			Calendar trueOutgoingDate = expectedOutgoingDate;

			ReservationTo newReservation = new ReservationTo(null, "Nieto", "12345678P", "", "5489250027023605", "658319325", "Rexistrada",
					incomingDate, expectedOutgoingDate, trueOutgoingDate, particular.getClientId(), agency.getClientId(), company.getClientId(),
					"",false);

			RequestTo newRequest = new RequestTo(newReservation.getReservationId(), particular.getClientId(), room2.getRoomCode(),
					board.getBoardCode(), priceType.getPriceTypeCode());

			Collection<RequestTo> newRequests = new HashSet<RequestTo>();
			newRequests.add(newRequest);

			newReservation = delegate.makeAReservation(newReservation, newRequests);

			delegate.removeAReservation(newReservation);

			assertTrue("registeredReservation", false);

		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBoardException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePriceTypeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAgencyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePayerException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnavailableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
		} catch (RegisteredReservationException e) {

			assertTrue("registeredReservation", true);

		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();				
		}


	}

	public void testDoubleReservation() {

		try {		

			Calendar bornDate = Calendar.getInstance();
			bornDate.set(1967,10,17,0,0,0);

			Calendar expeditionDate = Calendar.getInstance();
			expeditionDate.set(2002,2,25,0,0,0);

			Calendar expirationDate = Calendar.getInstance();
			expirationDate.set(2007,2,25,0,0,0);

			ParticularTo particular2 = new ParticularTo(null,address.getAddressId(),"Ceiln","","981886186","625664271","",
					"angelfn@gmail.com","www.angel.com", bank.getBankId(), card.getCardId(), "Sen observacins",
					"Jos Angel", "Ferreiro", "Nieto", bornDate, "DNI", "87654321P", expeditionDate, expirationDate, "H", "Espaa",
					"Tcnico", null, "Contado", "1234567890123456", "", "", "");

			Calendar incomingDate = Calendar.getInstance();
			incomingDate.set(2007,2,1,0,0,0);

			Calendar expectedOutgoingDate = Calendar.getInstance();
			expectedOutgoingDate.set(2007,2,15,0,0,0);

			Calendar trueOutgoingDate = expectedOutgoingDate;

			ReservationTo newReservation = new ReservationTo(null, "Davide", "44841107P", "", "5489250027023605", "658319325", "Pendente",
					incomingDate, expectedOutgoingDate, trueOutgoingDate, particular.getClientId(), agency.getClientId(), company.getClientId(),
					"",false);

			RequestTo request = new RequestTo(reservation.getReservationId(), particular.getClientId(), room2.getRoomCode(),
					board.getBoardCode(), priceType.getPriceTypeCode());

			RequestTo request2 = new RequestTo(reservation.getReservationId(), particular2.getClientId(), room2.getRoomCode(),
					board.getBoardCode(), priceType.getPriceTypeCode());

			Collection <RequestTo> newRequests = new HashSet <RequestTo> ();

			requests.add(request);
			requests.add(request2);

			newReservation = delegate.makeAReservation(newReservation, newRequests);

			Collection obtainedRequests = testDelegate.reservationRequests(newReservation.getReservationId());

			boolean test = true;

			Iterator iter1 = newRequests.iterator();
			Iterator iter2 = obtainedRequests.iterator();

			for (int i=0; iter1.hasNext(); i++) {

				test = test && (((RequestTo) iter1.next()).getParticular()).equals(((RequestTo) iter2.next()).getParticular())
				&& (((RequestTo) iter1).getRoom()).equals(((RequestTo) iter2).getRoom())
				&& (((RequestTo) iter1).getBoard()).equals(((RequestTo) iter2).getBoard())
				&& (((RequestTo) iter1).getPriceType()).equals(((RequestTo) iter2).getPriceType());

			}

			delegate.removeAReservation(newReservation);

			assertTrue("doubleReservation", test);

		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableBoardException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePriceTypeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableAgencyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptablePayerException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableCompanyException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnavailableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (InvalidIntervalException e) {
			e.printStackTrace();
			fail();
		} catch (RegisteredReservationException e) {
			e.printStackTrace();
			fail();					
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();				
		}

	}

	public void testCheckIn () {

		/*Days and Prices must be in database*/

	/*Do the check in at "onSetUpBeforeTransaction"*/

	 
		assertTrue("checkIn", true);


	}

	public void testFindACheckIn() {

		try {

			ReservationTo obtainedReservation = delegate.findACheckIn(reservation.getReservationId());

			boolean test = obtainedReservation.getReservationId().equals(reservation.getReservationId())
			&& obtainedReservation.getReservatorName().equals(reservation.getReservatorName())
			&& obtainedReservation.getReservatorCif().equals(reservation.getReservatorCif())
			&& obtainedReservation.getReservatorAccount().equals(reservation.getReservatorAccount())
			&& obtainedReservation.getReservatorCard().equals(reservation.getReservatorCard())
			&& obtainedReservation.getReservatorPhone().equals(reservation.getReservatorPhone())
			&& obtainedReservation.getReservationStatus().equals(reservation.getReservationStatus())
			&& obtainedReservation.getIncomingDate().equals(reservation.getIncomingDate())
			&& obtainedReservation.getExpectedOutgoingDate().equals(reservation.getExpectedOutgoingDate())
			&& obtainedReservation.getTrueOutgoingDate().equals(reservation.getTrueOutgoingDate())
			&& obtainedReservation.getPayer().equals(reservation.getPayer())
			&& obtainedReservation.getAgency().equals(reservation.getAgency())
			&& obtainedReservation.getCompany().equals(reservation.getCompany())
			&& obtainedReservation.getNotes().equals(reservation.getNotes())
			&& obtainedReservation.getByHours() == reservation.getByHours();

			assertTrue("FindACheckIn", test);

		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();			
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testFindAllCheckIns() {

		try {

			Collection checkins = delegate.findAllCheckIns();

			Iterator iter = checkins.iterator();

			ReservationTo currentReservation;
			boolean test = false;

			for(int i=0; iter.hasNext();i++) {

				currentReservation = (ReservationTo) iter.next();

				test = currentReservation.getReservationId().equals(reservation.getReservationId())
				&& currentReservation.getReservatorName().equals(reservation.getReservatorName())
				&& currentReservation.getReservatorCif().equals(reservation.getReservatorCif())
				&& currentReservation.getReservatorAccount().equals(reservation.getReservatorAccount())
				&& currentReservation.getReservatorCard().equals(reservation.getReservatorCard())
				&& currentReservation.getReservatorPhone().equals(reservation.getReservatorPhone())
				&& currentReservation.getReservationStatus().equals(reservation.getReservationStatus())
				&& currentReservation.getIncomingDate().equals(reservation.getIncomingDate())
				&& currentReservation.getExpectedOutgoingDate().equals(reservation.getExpectedOutgoingDate())
				&& currentReservation.getTrueOutgoingDate().equals(reservation.getTrueOutgoingDate())
				&& currentReservation.getPayer().equals(reservation.getPayer())
				&& currentReservation.getAgency().equals(reservation.getAgency())
				&& currentReservation.getCompany().equals(reservation.getCompany())
				&& currentReservation.getNotes().equals(reservation.getNotes())
				&& currentReservation.getByHours() == reservation.getByHours();

			}

			assertTrue("FindAllCheckIns", test);

		} catch (InternalErrorException e) {		
			e.printStackTrace();
			fail();
		}		

	}

	public void testRemoveACheckIn() {

		/* CheckIn must be done */

	/* Do the remove at OnTearDownAfterTransaction */

	 assertTrue("RemoveACheckIn", true);

	}

	public void testCheckOut() {

		/* Do the CheckOut at OsSetupBeforeTransaction */
	 
		assertTrue("CheckOut", true);

	}

	public void testFindACheckOut() {

		try {

			ReservationTo obtainedReservation = delegate.findACheckOut(reservation2.getReservationId());

			boolean test = obtainedReservation.getReservationId().equals(reservation2.getReservationId())
			&& obtainedReservation.getReservatorName().equals(reservation2.getReservatorName())
			&& obtainedReservation.getReservatorCif().equals(reservation2.getReservatorCif())
			&& obtainedReservation.getReservatorAccount().equals(reservation2.getReservatorAccount())
			&& obtainedReservation.getReservatorCard().equals(reservation2.getReservatorCard())
			&& obtainedReservation.getReservatorPhone().equals(reservation2.getReservatorPhone())
			&& obtainedReservation.getReservationStatus().equals(reservation2.getReservationStatus())
			&& obtainedReservation.getIncomingDate().equals(reservation2.getIncomingDate())
			&& obtainedReservation.getExpectedOutgoingDate().equals(reservation2.getExpectedOutgoingDate())
			&& obtainedReservation.getTrueOutgoingDate().equals(reservation2.getTrueOutgoingDate())
			&& obtainedReservation.getPayer().equals(reservation2.getPayer())
			&& obtainedReservation.getAgency().equals(reservation2.getAgency())
			&& obtainedReservation.getCompany().equals(reservation2.getCompany())
			&& obtainedReservation.getNotes().equals(reservation2.getNotes())
			&& obtainedReservation.getByHours() == reservation2.getByHours();

			assertTrue("FindACheckOut", test);

		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();			
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testFindAllCheckOuts() {

		try {

			Collection checkouts = delegate.findAllCheckOuts();

			Iterator iter = checkouts.iterator();

			ReservationTo currentReservation;
			boolean test = false;

			for(int i=0; iter.hasNext();i++) {

				currentReservation = (ReservationTo) iter.next();

				test = currentReservation.getReservationId().equals(reservation2.getReservationId())
				&& currentReservation.getReservatorName().equals(reservation2.getReservatorName())
				&& currentReservation.getReservatorCif().equals(reservation2.getReservatorCif())
				&& currentReservation.getReservatorAccount().equals(reservation2.getReservatorAccount())
				&& currentReservation.getReservatorCard().equals(reservation2.getReservatorCard())
				&& currentReservation.getReservatorPhone().equals(reservation2.getReservatorPhone())
				&& currentReservation.getReservationStatus().equals(reservation2.getReservationStatus())
				&& currentReservation.getIncomingDate().equals(reservation2.getIncomingDate())
				&& currentReservation.getExpectedOutgoingDate().equals(reservation2.getExpectedOutgoingDate())
				&& currentReservation.getTrueOutgoingDate().equals(reservation2.getTrueOutgoingDate())
				&& currentReservation.getPayer().equals(reservation2.getPayer())
				&& currentReservation.getAgency().equals(reservation2.getAgency())
				&& currentReservation.getCompany().equals(reservation2.getCompany())
				&& currentReservation.getNotes().equals(reservation2.getNotes())
				&& currentReservation.getByHours() == reservation2.getByHours();

			}

			assertTrue("FindAllCheckOuts", test);

		} catch (InternalErrorException e) {		
			e.printStackTrace();
			fail();
		}		

	}
	 
	public void testOweAddition() {

		try {

			Calendar currentDate = Calendar.getInstance();

			ConceptDao conceptDao = SpringDaoFactory.getConceptDao();
			ConceptTo conceptTo = conceptDao.find(ConfigurationHandler.STAY_CONCEPT);
			long vat = conceptTo.getVat();
			BigDecimal amount = MoneyOperations.getPriceWithVat(price.getValue(),vat);
			BigDecimal discount = new BigDecimal(0);
			String status = "Pendente";
			Long invoiceNumber = null;
			String invoiceSerial = null;
			String concept = conceptTo.getConceptCode();

			OweTo newOwe = new OweTo(null,currentDate,price.getValue(),vat,amount,discount,status,particular.getClientId(), room.getRoomCode(),invoiceNumber,invoiceSerial,concept, reservation.getReservationId());

			newOwe = delegate.oweAddition(newOwe);

			OweTo obtainedOwe = testDelegate.findOwe(reservation.getReservationId(), newOwe.getOweNumber());

			boolean test = (newOwe.getOweNumber()).equals(obtainedOwe.getOweNumber())
			&& (newOwe.getOweDate()).equals(obtainedOwe.getOweDate())
			&& (newOwe.getPrice()).equals(obtainedOwe.getPrice())
			&& newOwe.getVat() == obtainedOwe.getVat()
			&& (newOwe.getAmount()).equals(obtainedOwe.getAmount())
			&& (newOwe.getDiscount()).equals(obtainedOwe.getDiscount())
			&& (newOwe.getStatus()).equals(obtainedOwe.getStatus())
			&& (newOwe.getParticular()).equals(obtainedOwe.getParticular())
			&& (newOwe.getRoom()).equals(obtainedOwe.getRoom())
			//&& (newOwe.getInvoiceNumber()).equals(obtainedOwe.getInvoiceNumber())
			//&& (newOwe.getInvoiceSerial()).equals(obtainedOwe.getInvoiceSerial())
			&& (newOwe.getConcept()).equals(obtainedOwe.getConcept())
			&& (newOwe.getReservation()).equals(obtainedOwe.getReservation());

			assertTrue("OweAddition", test);

		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableConceptException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableInvoiceException e) {
			e.printStackTrace();
			fail();
		} catch (RoomNotBusyException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {			
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		} 

	}

	public void testFindOwesByRoomAndParticular() {

		try{

			Calendar currentDate = Calendar.getInstance();

			ConceptDao conceptDao = SpringDaoFactory.getConceptDao();
			ConceptTo conceptTo = conceptDao.find(ConfigurationHandler.STAY_CONCEPT);
			long vat = conceptTo.getVat();
			BigDecimal amount = MoneyOperations.getPriceWithVat(price.getValue(),vat);
			BigDecimal discount = new BigDecimal(0);
			String status = "Pendente";
			Long invoiceNumber = null;
			String invoiceSerial = null;
			String concept = conceptTo.getConceptCode();

			OweTo newOwe = new OweTo(null,currentDate,price.getValue(),vat,amount,discount,status,particular.getClientId(), room.getRoomCode(),invoiceNumber,invoiceSerial,concept, reservation.getReservationId());

			newOwe = delegate.oweAddition(newOwe);

			Collection obtainedOwes = delegate.findOwesByRoomAndParticular(room.getRoomCode(), particular.getClientId());

			Iterator iter = obtainedOwes.iterator();

			OweTo currentOwe;

			boolean test = false;

			for (int i=0; iter.hasNext(); i++) {

				currentOwe = (OweTo) iter.next();

				/*There are 16 owes in database */

				if (i==15) {

					test = (newOwe.getOweNumber()).equals(currentOwe.getOweNumber())
					&& (newOwe.getOweDate()).equals(currentOwe.getOweDate())
					&& (newOwe.getPrice()).equals(currentOwe.getPrice())
					&& newOwe.getVat() == currentOwe.getVat()
					&& (newOwe.getAmount()).equals(currentOwe.getAmount())
					&& (newOwe.getDiscount()).equals(currentOwe.getDiscount())
					&& (newOwe.getStatus()).equals(currentOwe.getStatus())
					&& (newOwe.getParticular()).equals(currentOwe.getParticular())
					&& (newOwe.getRoom()).equals(currentOwe.getRoom())
					//&& (newOwe.getInvoiceNumber()).equals(currentOwe.getInvoiceNumber())
					//&& (newOwe.getInvoiceSerial()).equals(currentOwe.getInvoiceSerial())
					&& (newOwe.getConcept()).equals(currentOwe.getConcept())
					&& (newOwe.getReservation()).equals(currentOwe.getReservation());

				}

			}

			assertTrue("OwesByRoomAndParticular", test);

		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableConceptException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableInvoiceException e) {
			e.printStackTrace();
			fail();
		} catch (RoomNotBusyException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {			
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		} 


	}

	public void testFindReservationOwes() {

		try{

			Calendar currentDate = Calendar.getInstance();

			ConceptDao conceptDao = SpringDaoFactory.getConceptDao();
			ConceptTo conceptTo = conceptDao.find(ConfigurationHandler.STAY_CONCEPT);
			long vat = conceptTo.getVat();
			BigDecimal amount = MoneyOperations.getPriceWithVat(price.getValue(),vat);
			BigDecimal discount = new BigDecimal(0);
			String status = "Pendente";
			Long invoiceNumber = null;
			String invoiceSerial = null;
			String concept = conceptTo.getConceptCode();

			OweTo newOwe = new OweTo(null,currentDate,price.getValue(),vat,amount,discount,status,particular.getClientId(), room.getRoomCode(),invoiceNumber,invoiceSerial,concept, reservation.getReservationId());

			newOwe = delegate.oweAddition(newOwe);

			Collection obtainedOwes = delegate.findReservationOwes(reservation.getReservationId());

			Iterator iter = obtainedOwes.iterator();

			OweTo currentOwe;

			boolean test = false;

			for (int i=0; iter.hasNext(); i++) {

				currentOwe = (OweTo) iter.next();

				/*There are 16 owes in database */

				if (i==15) {

					test = (newOwe.getOweNumber()).equals(currentOwe.getOweNumber())
					&& (newOwe.getOweDate()).equals(currentOwe.getOweDate())
					&& (newOwe.getPrice()).equals(currentOwe.getPrice())
					&& newOwe.getVat() == currentOwe.getVat()
					&& (newOwe.getAmount()).equals(currentOwe.getAmount())
					&& (newOwe.getDiscount()).equals(currentOwe.getDiscount())
					&& (newOwe.getStatus()).equals(currentOwe.getStatus())
					&& (newOwe.getParticular()).equals(currentOwe.getParticular())
					&& (newOwe.getRoom()).equals(currentOwe.getRoom())
					//&& (newOwe.getInvoiceNumber()).equals(currentOwe.getInvoiceNumber())
					//&& (newOwe.getInvoiceSerial()).equals(currentOwe.getInvoiceSerial())
					&& (newOwe.getConcept()).equals(currentOwe.getConcept())
					&& (newOwe.getReservation()).equals(currentOwe.getReservation());

				}

			}

			assertTrue("ReservationOwes", test);


		} catch (UnaceptableReservationException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableConceptException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableInvoiceException e) {
			e.printStackTrace();
			fail();
		} catch (RoomNotBusyException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {			
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		} 

	}

	public void testRemoveAnOwe() {

		try{

			Calendar currentDate = Calendar.getInstance();

			ConceptDao conceptDao = SpringDaoFactory.getConceptDao();
			ConceptTo conceptTo = conceptDao.find(ConfigurationHandler.STAY_CONCEPT);
			long vat = conceptTo.getVat();
			BigDecimal amount = MoneyOperations.getPriceWithVat(price.getValue(),vat);
			BigDecimal discount = new BigDecimal(0);
			String status = "Pendente";
			Long invoiceNumber = null;
			String invoiceSerial = null;
			String concept = conceptTo.getConceptCode();

			OweTo newOwe = new OweTo(null,currentDate,price.getValue(),vat,amount,discount,status,particular.getClientId(), room.getRoomCode(),invoiceNumber,invoiceSerial,concept, reservation.getReservationId());

			newOwe = delegate.oweAddition(newOwe);

			delegate.removeAnOwe(newOwe);

			testDelegate.findOwe(reservation.getReservationId(), newOwe.getOweNumber());

			assertTrue("RemoveAnOwe", false);

		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableConceptException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableParticularException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableInvoiceException e) {
			e.printStackTrace();
			fail();
		} catch (RoomNotBusyException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {			

			assertTrue("RemoveAnOwe", true);

		} catch (InternalErrorException e) {
			e.printStackTrace();
			fail();
		}

	}

	public void testBlockARoom() {

		try {

			delegate.blockARoom(room);

			RoomTo obtainedRoom = testDelegate.findRoom(room.getRoomCode());

			boolean test = obtainedRoom.getOccupancyStatus().equals("Bloqueada");

			assertTrue("BlockARoom", test);

		} catch (RoomBusyException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {	
			e.printStackTrace();
			fail();
		}

	}

	public void testUnblockARoom() {

		try {

			delegate.unblockARoom(room);

			testDelegate.findRoom(room.getRoomCode());

			boolean test = room.getOccupancyStatus().equals("Libre");

			assertTrue("UnblockARoom", test);

		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
			fail();
		}catch (InternalErrorException e) {	
			e.printStackTrace();
			fail();
		} 

	}

	public void testDoAWash() {

		try {

			WashTo newWash = new WashTo(null,Calendar.getInstance(),true, false, true, true, false, false, room.getRoomCode(), employee.getEmployeeId(),"");

			newWash = delegate.doAWash(newWash);
			
			WashTo obtainedWash = testDelegate.findWash(room.getRoomCode(), employee.getEmployeeId(), newWash.getWashId());
			
			boolean test = obtainedWash.getWashId().equals(newWash.getWashId())
			&& obtainedWash.getWashDate().equals(newWash.getWashDate())
			&& obtainedWash.isInWash() == newWash.isInWash()
			&& obtainedWash.isOutWash() == newWash.isOutWash()
			&& obtainedWash.isTowels() == newWash.isTowels()
			&& obtainedWash.isSheets() == newWash.isSheets()
			&& obtainedWash.isDisinfection() == newWash.isDisinfection()
			&& obtainedWash.isOther() == newWash.isOther()
			&& obtainedWash.getRoom().equals(newWash.getRoom())
			&& obtainedWash.getEmployee().equals(newWash.getEmployee())
			&& obtainedWash.getObservations().equals(newWash.getObservations());
			
			assertTrue("DoAWash", test);
			
		} catch (UnaceptableEmployeeException e) {
			e.printStackTrace();
			fail();
		} catch (UnaceptableRoomException e) {
			e.printStackTrace();
			fail();
		} catch (InstanceNotFoundException e) {		
			e.printStackTrace();
			fail();
		} catch (InternalErrorException e) {		
			e.printStackTrace();
			fail();
		} 

	}

}
