/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package controllerpatatero;

import java.util.Collection;

import gz.cyberbrain.cyberhotel.model.bank.to.BankTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.BankWithClientsException;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class BankCreator {

	private Long bankId;
	private String name;
	private String logo;

	public BankCreator(Long bankId, String name, String logo) {

		this.bankId = bankId;
		this.name = name;
		this.logo = logo;
	}

	public void createNewBank() throws InternalErrorException {

		ConfigurationFacadeDelegate delegate =
			SpringFacadeFactory.getConfigurationFacadeDelegate();

		BankTo bankTo = 
			new BankTo();
		bankTo.setBankId(bankId);
		bankTo.setName(name);
		bankTo.setLogo(logo);

		delegate.createBank(bankTo);

	}		

	public void updateBank() throws InternalErrorException {

		ConfigurationFacadeDelegate delegate =
			SpringFacadeFactory.getConfigurationFacadeDelegate();

		BankTo bankTo = 
			new BankTo();
		bankTo.setBankId(bankId);
		bankTo.setName(name);
		bankTo.setLogo(logo);                

		delegate.updateBank(bankTo);

	}

	public void deleteBank() throws InternalErrorException {

		try {

			ConfigurationFacadeDelegate delegate =
				SpringFacadeFactory.getConfigurationFacadeDelegate();

			BankTo bankTo = 
				new BankTo();
			bankTo.setBankId(bankId);
			bankTo.setName(name);
			bankTo.setLogo(logo);                

			delegate.deleteBank(bankTo);

		} catch (BankWithClientsException e) {
			e.printStackTrace();
		}

	}

	public Collection showBanks() throws InternalErrorException {

		ConfigurationFacadeDelegate delegate =
			SpringFacadeFactory.getConfigurationFacadeDelegate();



		return delegate.showBanks();

	}



}
