/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package controllerpatatero;

import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomWithBoardersException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableRoomTypeException;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public class RoomCreator {

	private String roomCode;
	private String number;
	private long floor;
	private String type;
	private String occupancyStatus;
	private String cleaningStatus;
	private Calendar checkingDate;
	private boolean smokers;
	private long maxPax;
	private String notes;


	public RoomCreator(String roomCode, String number, long floor, String type, String occupancyStatus, String cleaningStatus, Calendar checkingDate, boolean smokers, long maxPax, String notes, Collection boarders) {

		this.roomCode = roomCode;
		this.number = number;
		this.floor = floor;
		this.type = type;
		this.occupancyStatus = occupancyStatus;
		this.cleaningStatus = cleaningStatus;
		this.checkingDate = checkingDate;
		this.smokers = smokers;
		this.maxPax = maxPax;
		this.notes = notes;
	}



	public void createNewRoom() throws UnaceptableRoomTypeException, InternalErrorException {




		/* Create an "ExerciseFacadeDelegate". */
		ConfigurationFacadeDelegate delegate =
			SpringFacadeFactory.getConfigurationFacadeDelegate();

		RoomTo roomTo = 
			new RoomTo(roomCode, number, floor, type, occupancyStatus, cleaningStatus, checkingDate, smokers, maxPax, notes);                

		delegate.createRoom(roomTo);



	}		

	public Collection showRooms() throws InternalErrorException {

		ConfigurationFacadeDelegate delegate =
			SpringFacadeFactory.getConfigurationFacadeDelegate();



		return delegate.showRooms();

	}

	public void deleteRoom() throws InternalErrorException {

		try {	

			ConfigurationFacadeDelegate delegate =
				SpringFacadeFactory.getConfigurationFacadeDelegate();

			RoomTo roomTo = 
				new RoomTo();
			roomTo.setRoomCode(roomCode);
			roomTo.setType(type);
			roomTo.setNumber(number);
			roomTo.setOccupancyStatus(occupancyStatus);
			roomTo.setCleaningStatus(cleaningStatus);


			delegate.deleteRoom(roomTo);

		}catch (RoomWithBoardersException e){
			e.printStackTrace();
		}

	}

}
