/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RegisteredReservationException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class GroupPendingReservationListAdapter extends ListAdapter {

	@Override
	public SaveAdapter getCreator() {
		return new ReservationCreator();
	}

	@Override
	public SaveAdapter getUpdater() {
		return new ReservationUpdater();
	}


	@SuppressWarnings("unchecked")
	@Override
	public Vector load() {
		Vector aux = new Vector();
		Vector list = new Vector();

		try {
			aux = ReservationController.unregisteredReservations();

			for (int i=0; i < aux.size(); i++) {

				if (ReservationController.reservationRequests((Long) ((TextItem) aux.elementAt(i)).getId()).size() > 1) 
					list.add(aux.elementAt(i));

			}

		} catch (InternalErrorException e) {
			e.printStackTrace();
		}

		return list;

	}


	public void delete(Serializable id) {

		try {
			ErrorsHandler.clear();
			ReservationController.deleteReservation((Long) id);
		} catch (InstanceNotFoundException e) {		
			e.printStackTrace();
		} catch (RegisteredReservationException e) {			
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = ReservationController.findReservation((Long) id);
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
		return map;
	}
	
}
