/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidDocumentTypeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidPayModeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidSexException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAddressException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableBankException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCardException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCompanyException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InvalidIntervalException;

import java.io.Serializable;
import java.util.Calendar;
import java.util.HashMap;

public class ParticularUpdater extends SaveAdapter {

	public Serializable save(HashMap map) {
		try {

			if (inputTesting(map))
				ParticularController.updateParticular((Long) map.get("id"), (Long) map.get("address"), (String) map.get("street"), (String) map.get("dwellingPlace"), 
						(String) map.get("phone1"), (String) map.get("phone2"), (String) map.get("fax"), (String) map.get("email"), (String) map.get("web"), (Long) map.get("bank"), (Long) map.get("card"), (String) map.get("notes"), 
						(String) map.get("name"), (String) map.get("firstSurname"), (String) map.get("secondSurname"), (Calendar) map.get("bornDate"), (String) map.get("documentType"), 
						(String) map.get("documentNumber"), (Calendar) map.get("expeditionDate"), (Calendar) map.get("expirationDate"), (String) map.get("sex"), (String) map.get("nationality"), 
						(String) map.get("job"), (Long) map.get("company"), (String) map.get("payMode"), (String) map.get("accountNumber"), (String) map.get("cardNumber"), (String) map.get("voucherCode"), 
						(String) map.get("clientType"));

		} catch (InvalidSexException e) {
			e.printStackTrace();
		} catch (InvalidDocumentTypeException e) {
			e.printStackTrace();
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
		} catch (UnaceptableAddressException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));
		} catch (UnaceptableCompanyException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("company"));
		} catch (UnaceptableBankException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("bank"));
		} catch (UnaceptableCardException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("card"));
		} catch (InvalidIntervalException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("interval"));
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		} catch (InternalErrorException e) {			
			e.printStackTrace();
		} 		
		return (Long) map.get("id");
	}

	protected boolean inputTesting(HashMap map) {

		if (((String) map.get("name")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("name"));
			return false;
		}

		if (((String) map.get("firstSurname")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("firstSurname"));
			return false;
		}

		if (((String) map.get("secondSurname")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("secondSurname"));
			return false;
		}

		if (((String) map.get("documentNumber")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("name"));
			return false;
		}

		ErrorsHandler.clear();

		return true;

	}

}
