/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class PaymentListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new PaymentCreator();
	}
	
	public SaveAdapter getUpdater() {
		return new PaymentUpdater();
	}
	
	@SuppressWarnings("unchecked")
	public Vector load() {
		
		Vector items = new Vector();
		
		items = PaymentController.paymentList();
		
		return items;

	}

	public void delete(Serializable id) {
		
		try {
			ErrorsHandler.clear();
			PaymentController.deletePayment((Long) id);
		} catch (InstanceNotFoundException e) {		
			e.printStackTrace();	
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = PaymentController.findPayment((Long) id);
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
        } catch (InternalErrorException e) {
        	e.printStackTrace();
        }
        return map;
	}

}
