/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.address.dao;

import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface AddressDao {

	public AddressTo create(AddressTo addressTo) throws InternalErrorException;

	public AddressTo find(Long addressId) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (AddressTo addressTo) 
		throws InternalErrorException;
	
	public void remove(AddressTo addressTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findCountries() throws InternalErrorException;
	
	public Collection findProvincesByCountry(String country) throws InternalErrorException;
	
	public Collection findLocalitiesByProvince(String country, String province) throws InternalErrorException;
	
	public Collection findByCountry(String country) throws InternalErrorException;
	
	public Collection findByProvince(String country, String province) throws InternalErrorException;
	
	public AddressTo findByLocality(String country, String province, String locality) throws InstanceNotFoundException, InternalErrorException;
	
	public AddressTo findByCompleteAddress(String country, String province, String locality) throws InstanceNotFoundException, InternalErrorException;
	
	public boolean existClients (Long addressId, String country) 
		throws InternalErrorException;
	
}
