/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.concept.dao;

import gz.cyberbrain.cyberhotel.model.concept.to.ConceptTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class ConceptSpringDao extends AbstractSpringDao implements ConceptDao {

	public ConceptSpringDao() {
		super(ConceptTo.class);
	}	

	public ConceptTo create(ConceptTo conceptTo) throws InternalErrorException {		

		return (ConceptTo) super.save(conceptTo);

	}

	public ConceptTo find(String conceptCode) throws InstanceNotFoundException, InternalErrorException {

		ConceptTo conceptTo = (ConceptTo) super.find(conceptCode);
		return conceptTo;

	}

	public void update(ConceptTo conceptTo) throws InternalErrorException {		

		super.update(conceptTo);

	}

	public void remove(ConceptTo conceptTo) throws InternalErrorException {

			super.delete(conceptTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allConcepts";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existOwes(String conceptCode) throws InternalErrorException {
		
		String queryName = "conceptOwes";
		return (!super.findByAttribute(queryName, conceptCode).isEmpty());
		
	}
	
}
