/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.SeasonInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.SeasonTariffiedException;
import gz.cyberbrain.cyberhotel.model.season.dao.SeasonDao;
import gz.cyberbrain.cyberhotel.model.season.to.SeasonTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteSeasonAction {

	private SeasonTo seasonTo;
	private SeasonDao seasonDao;

	public DeleteSeasonAction (SeasonTo seasonTo, SeasonDao seasonDao) {

		this.seasonTo = seasonTo;
		this.seasonDao = seasonDao;

	}

	public void execute() throws SeasonInUseException, SeasonTariffiedException, InternalErrorException {

		if (seasonDao.isTariffied(seasonTo.getSeasonId())) throw new SeasonTariffiedException(seasonTo);

		seasonDao.remove(seasonTo);

	}


}
