/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.day.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;

import java.io.Serializable;
import java.util.Calendar;

public class DayTo implements Identifiable {
	
	private static final long serialVersionUID = -6651223425175258597L;
	private Calendar dayDate;
	private Long season;
	
	public DayTo(){}
	
	public DayTo(Calendar dayDate, Long season) {				
		this.dayDate = DateOperations.getDateWithoutMilliseconds(dayDate);
		this.season = season;
	}

	public Serializable getId(){
		return dayDate;
	}
	
	public Calendar getDayDate() {
		return dayDate;
	}

	public void setDayDate(Calendar dayDate) {
		this.dayDate = DateOperations.getDateWithoutMilliseconds(dayDate);
	}

	public Long getSeason() {
		return season;
	}

	public void setSeason(Long season) {
		this.season = season;
	}						
	
}
