/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.employee.dao;

import java.util.Collection;

import gz.cyberbrain.cyberhotel.model.employee.to.EmployeeTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class EmployeeSpringDao extends AbstractSpringDao implements EmployeeDao{

	public EmployeeSpringDao() {
		super(EmployeeTo.class);
	}	

	public EmployeeTo create(EmployeeTo employeeTo) throws InternalErrorException {		

		return (EmployeeTo) super.save(employeeTo);

	}

	public EmployeeTo find(Long employeeId) throws InstanceNotFoundException, InternalErrorException {

		EmployeeTo employeeTo = (EmployeeTo) super.find(employeeId);
		return employeeTo;

	}

	public void update(EmployeeTo employeeTo) throws InternalErrorException {		

		super.update(employeeTo);

	}

	public void remove(EmployeeTo employeeTo) throws InternalErrorException {

			super.delete(employeeTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allEmployees";
		return super.findByQuery(queryName);
		
	}

	public Collection employeeWashes(Long employeeId) throws InternalErrorException {
		
		String queryName = "employeeWashes";
		return super.findByAttribute(queryName, employeeId);
		
	}
	
}
