/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.pricetype.dao;

import gz.cyberbrain.cyberhotel.model.pricetype.to.PriceTypeTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface PriceTypeDao {

	public PriceTypeTo create(PriceTypeTo prizeTypeTo) throws InternalErrorException;

	public PriceTypeTo find(String priceTypeCode) 
	throws InstanceNotFoundException, InternalErrorException;

	public void update (PriceTypeTo prizeTypeTo) 
	throws InternalErrorException;

	public void remove(PriceTypeTo prizeTypeTo) 
	throws InternalErrorException;

	public Collection findAll() throws InternalErrorException;

	public Collection findAllCodes() throws InternalErrorException;

	public boolean existRequests (String priceTypeCode) 
	throws InternalErrorException;

	public boolean isTariffied (String priceTypeCode)
	throws InternalErrorException;

}
