/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.request.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;

import java.io.Serializable;

public class RequestTo implements Identifiable {

	private static final long serialVersionUID = -3939448136613877130L;
	private Long reservation;
	private Long particular;
	private String room;
	private String board;
	private String priceType;
	
	public RequestTo(){}
	
	public RequestTo(Long reservation, Long particular, String room, String board, String priceType) {		
		this.reservation = reservation;
		this.particular = particular;
		this.room = room;
		this.board = board;		
		this.priceType = priceType;
	}

	public Serializable getId() {
		return new String(reservation + "-" + particular + "-" + room);
	}
	
	public String getBoard() {
		return board;
	}

	public void setBoard(String board) {
		this.board = board;
	}

	public Long getParticular() {
		return particular;
	}

	public void setParticular(Long particular) {
		this.particular = particular;
	}

	public String getPriceType() {
		return priceType;
	}
	
	public Long getReservation(){
		return reservation;
	}
	
	public void setReservation(Long reservation) {
		this.reservation = reservation;
	}

	public void setPriceType(String priceType) {
		this.priceType = priceType;
	}

	public String getRoom() {
		return room;
	}

	public void setRoom(String room) {
		this.room = room;
	}


	
	
}
