/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.util.exceptions;

import gz.cyberbrain.cyberhotel.model.util.dates.Interval;

public class OverlappingException extends ModelException {

	private static final long serialVersionUID = 2459326810549518669L;
	private Interval firstInterval;
	private Interval secondInterval;
	
    public OverlappingException(Interval firstInterval, Interval secondInterval) {
    	super("Overlapped Intervals Found: " + firstInterval + " <-> " + secondInterval);
    	this.firstInterval = firstInterval;
    	this.secondInterval = secondInterval;
    }
    
    public Interval getFirstInterval() {
    	return firstInterval;
    }
    
    public Interval getSecondInterval() {
    	return secondInterval;
    }
	
}
