/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.util.money;

import java.math.BigDecimal;

public final class MoneyOperations {
	
	private final static int NUMBER_OF_DECIMALS = 2;
	
	private MoneyOperations(){}

	public final static BigDecimal getDecimalReduction(BigDecimal money){
		
		return money.setScale(NUMBER_OF_DECIMALS, BigDecimal.ROUND_HALF_UP);
		
	}
	
	public final static BigDecimal getPriceWithVat(BigDecimal value, BigDecimal vat) {
		
		BigDecimal valueVat = (value.multiply(vat)).divide(new BigDecimal(100));
		
		return value.add(valueVat);
		
	}
	
}
