/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.security;

import java.util.ArrayList;
import java.util.Collection;

import org.acegisecurity.Authentication;
import org.acegisecurity.GrantedAuthority;
import org.acegisecurity.context.SecurityContextHolder;
import org.acegisecurity.context.SecurityContextImpl;
import org.acegisecurity.providers.AuthenticationProvider;
import org.acegisecurity.providers.UsernamePasswordAuthenticationToken;
import org.acegisecurity.userdetails.User;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class SecurityHandler {

	private static ApplicationContext context;

	static {
		context = new ClassPathXmlApplicationContext("applicationContext.xml");
	}

	private SecurityHandler(){}	

	public static void setSecureContext(final String username, final String password) {
		
		AuthenticationProvider provider = 
			(AuthenticationProvider) context.getBean("daoAuthenticationProvider");
		
		Authentication auth = 
			provider.authenticate(new UsernamePasswordAuthenticationToken(username, password));
		
		SecurityContextHolder.getContext().setAuthentication(auth);
				
	}

	private static Authentication getCurrentAuthentication(){
		if (SecurityContextHolder.getContext().getAuthentication() == null) System.out.println("MERDA!!!");
		return SecurityContextHolder.getContext().getAuthentication();
		
	}

	public static Collection getAuthenticationCredentials(){

		Authentication auth = getCurrentAuthentication();

		if (auth != null) {

			GrantedAuthority []auths = auth.getAuthorities();

			Collection<String>roles = new ArrayList<String>();				

			for (int i=0; i<auths.length; i++) 
				roles.add(auths[i].getAuthority());			

			return roles;

		} else 

			return null;

	}

	public static String getAuthenticatedLogin(){
		Authentication auth = getCurrentAuthentication();

		if (auth != null)
			return (String) ((User)auth.getPrincipal()).getUsername();
		else 
			return null;
	}

	public static void clearSecurityContext(){
		SecurityContextHolder.setContext(new SecurityContextImpl());
	}
		
}
