/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.start;

import gz.cyberbrain.cyberhotel.view.swing.util.gui.PathHandler;

import javax.swing.JPanel;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Toolkit;

import javax.swing.ImageIcon;
import javax.swing.JWindow;
import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;

import java.awt.Rectangle;
import javax.swing.JLabel;

public class SplashScreen extends JWindow {

	private static final long serialVersionUID = 1L;
	private static SplashScreen splashScreen = null;
	private static Frame owner = new Frame();;
	private JPanel barPanel = null;
	private JProgressBar jProgressBar = null;
	private JPanel jContentPane = null;
	private JPanel imagePanel = null;
	private String path = PathHandler.getImagesPath();  //  @jve:decl-index=0:
	private JLabel infoLabel = null;
	private JPanel infoPanel = null;

	/**
	 * @param owner
	 */
	private SplashScreen(Frame owner) {		
		super(owner);
		initialize();
	}

	public static SplashScreen getInstance() {
		if (splashScreen == null) splashScreen = new SplashScreen(owner);
		return splashScreen;
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 90);
		this.setContentPane(getJContentPane());
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		this.setLocation((screen.width - this.getWidth())/2, (screen.height - this.getHeight())/2);		
	}

	/**
	 * This method initializes barPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBarPanel() {
		if (barPanel == null) {
			barPanel = new JPanel();
			barPanel.setLayout(new BorderLayout());
			barPanel.setBounds(new Rectangle(15, 69, 473, 5));
			barPanel.add(getJProgressBar(), BorderLayout.CENTER);
			barPanel.setOpaque(false);
		}
		return barPanel;
	}

	/**
	 * This method initializes jProgressBar	
	 * 	
	 * @return javax.swing.JProgressBar	
	 */
	private JProgressBar getJProgressBar() {
		if (jProgressBar == null) {
			jProgressBar = new JProgressBar();
			jProgressBar.setBackground(Color.WHITE);
			jProgressBar.setForeground(Color.MAGENTA);
		}
		return jProgressBar;
	}

	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getImagePanel(), null);
		}
		return jContentPane;
	}

	private JLabel getInfoLabel() {
		if (infoLabel == null) {
			infoLabel = new JLabel();
			infoLabel.setForeground(Color.WHITE);
			infoLabel.setBounds(new Rectangle(2, 2, 492, 12));
			infoLabel.setOpaque(false);
		}
		return infoLabel;
	}
	/**
	 * This method initializes imagePanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getImagePanel() {
		if (imagePanel == null) {
			imagePanel = new JPanel();
			imagePanel.setLayout(null);
			imagePanel.setBounds(new Rectangle(0, 0, 500, 90));						
			imagePanel.add(getBarPanel(), null);
			imagePanel.add(getInfoPanel(), null);
			JLabel imageLabel = new JLabel(new ImageIcon(path + "splash.png"));
			imageLabel.setBounds(0, 0, 500, 90);
			imagePanel.add(imageLabel);
		}
		return imagePanel;
	}

	public void increase(int value) {
		int newValue = getJProgressBar().getValue() + value;
		getJProgressBar().setValue(Math.min(newValue, 100));
	}

	/*private ImageIcon getLogo() {
		ImageIcon splash = new ImageIcon(path + "splash.png"); 
		return new ImageIcon(splash.getImage().
				getScaledInstance(500, 80, Image.SCALE_SMOOTH));
	}*/
	
	public void setInfoText(String text) {
		getInfoLabel().setText(text);
	}
	
	public void hideSplash() {
		SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                owner.dispose();
                dispose();
            }
        });
	}

	/**
	 * This method initializes infoPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new JPanel();
			infoPanel.setLayout(null);
			infoPanel.setBounds(new Rectangle(5, 50, 495, 15));
			infoPanel.add(getInfoLabel(), null);
			infoPanel.setOpaque(false);
		}
		return infoPanel;
	}
}  //  @jve:decl-index=0:visual-constraint="41,10"
